/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT2.dat, Sat Nov 26 21:55:29 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000008C6 (2246)
 *     Revision         0x01
 *     Checksum         0xA8
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "SataPri"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20061109 (537268489)
 */
DefinitionBlock ("SSDT2.aml", "SSDT", 1, "LENOVO", "SataPri", 0x00001000)
{
    External (\DPP4, IntObj)
    External (\DPP2, IntObj)
    External (\DPP0, IntObj)
    External (\FPIO, IntObj)
    External (\FDMA, MethodObj)    // 2 Arguments
    External (\DUDM, MethodObj)    // 2 Arguments
    External (\DPIO, MethodObj)    // 2 Arguments
    External (\_SB_.PCI0.SAT1, DeviceObj)
    External (\_SB_.PCI0.SAT0, DeviceObj)

    Scope (\_SB.PCI0.SAT0)
    {
        Device (PRIM)
        {
            Name (_ADR, Zero)
            Name (BGTM, Buffer (0x14) {})
            CreateDWordField (BGTM, Zero, GTP0)
            CreateDWordField (BGTM, 0x04, GTD0)
            CreateDWordField (BGTM, 0x08, GTP1)
            CreateDWordField (BGTM, 0x0C, GTD1)
            CreateDWordField (BGTM, 0x10, GTMF)
            Name (BPI0, Zero)
            Name (BDM0, Zero)
            Name (BPI1, Zero)
            Name (BDM1, Zero)
            Name (DIP0, Zero)
            Name (DIP1, Zero)
            Name (GTME, Zero)
            Method (_GTM, 0, NotSerialized)
            {
                If (LNot (GTME))
                {
                    Or (GTMF, One, GTMF)
                    Store (0x78, GTP0)
                    Store (0x14, GTD0)
                    Store (Zero, GTP1)
                    Store (Zero, GTD1)
                    Or (GTMF, 0x10, GTMF)
                }

                Store (One, GTME)
                Return (BGTM)
            }

            Method (_STM, 3, NotSerialized)
            {
                CreateDWordField (Arg0, Zero, STP0)
                CreateDWordField (Arg0, 0x04, STD0)
                CreateDWordField (Arg0, 0x08, STP1)
                CreateDWordField (Arg0, 0x0C, STD1)
                CreateDWordField (Arg0, 0x10, STMF)
                Store (STP0, GTP0)
                Store (STD0, GTD0)
                Store (STMF, GTMF)
                Store (Zero, DIP0)
                Store (Zero, DIP1)
                If (LEqual (SizeOf (Arg1), 0x0200))
                {
                    CreateWordField (Arg1, 0x9C, M078)
                    If (LAnd (^MSTR.DIPP (), And (M078, 0x08)))
                    {
                        Store (One, DIP0)
                    }

                    Store (\DPIO (STP0, And (STMF, 0x02)), Local0)
                    Store (\DUDM (STD0, And (STMF, One)), Local1)
                    Store (\FDMA (Local0, Local1), BDM0)
                    Store (\FPIO, Local0)
                    BPI0
                }

                If (LEqual (SizeOf (Arg2), 0x0200))
                {
                    CreateWordField (Arg2, 0x9C, S078)
                    If (LAnd (^SLAV.DIPP (), And (S078, 0x08)))
                    {
                        Store (One, DIP1)
                    }

                    Store (\DPIO (STP1, And (STMF, 0x08)), Local0)
                    Store (\DUDM (STD1, And (STMF, 0x04)), Local1)
                    Store (\FDMA (Local0, Local1), BDM1)
                    Store (\FPIO, Local0)
                    BPI1
                }
            }

            Device (MSTR)
            {
                Name (_ADR, Zero)
                Method (DIPP, 0, NotSerialized)
                {
                    Return (\DPP0)
                }

                Name (HDTF, Buffer (0x1C)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x03, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xA0, 0xEF
                })
                CreateByteField (HDTF, 0x0F, HDMA)
                CreateByteField (HDTF, 0x16, HPIO)
                Name (HPTF, Buffer (0x23)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x03, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00, 0x00, 
                    /* 0020 */    0x00, 0xA0, 0xEF
                })
                CreateByteField (HPTF, 0x0F, PDMA)
                CreateByteField (HPTF, 0x16, PPIO)
                Name (IDTF, Buffer (0x0E)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                })
                CreateByteField (IDTF, One, IDMA)
                CreateByteField (IDTF, 0x08, IPIO)
                Name (DDTF, Buffer (0x1C)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xA0, 0xE3
                })
                CreateByteField (DDTF, One, DDMA)
                CreateByteField (DDTF, 0x08, DPIO)
                CreateByteField (DDTF, 0x0F, DTAT)
                CreateByteField (DDTF, 0x16, DTFT)
                Name (DGTF, Buffer (0x23)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03, 0x00, 0x00, 
                    /* 0020 */    0x00, 0xA0, 0xEF
                })
                CreateByteField (DGTF, One, GDMA)
                CreateByteField (DGTF, 0x08, GPIO)
                CreateByteField (DGTF, 0x0F, GTAT)
                CreateByteField (DGTF, 0x16, GTFT)
                Method (_GTF, 0, NotSerialized)
                {
                    If (^^DIP0)
                    {
                        Store (^^BDM0, PDMA)
                        Store (^^BPI0, PPIO)
                        Return (HPTF)
                    }
                    Else
                    {
                        Store (^^BDM0, HDMA)
                        Store (^^BPI0, HPIO)
                        Return (HDTF)
                    }
                }
            }

            Device (SLAV)
            {
                Name (_ADR, One)
                Method (DIPP, 0, NotSerialized)
                {
                    Return (\DPP2)
                }

                Name (HDTF, Buffer (0x1C)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xB0, 0xF5, 0x03, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xB0, 0xEF
                })
                CreateByteField (HDTF, 0x0F, HDMA)
                CreateByteField (HDTF, 0x16, HPIO)
                Name (HPTF, Buffer (0x23)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xB0, 0xF5, 0x03, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xB0, 0xEF, 0x10, 0x03, 0x00, 0x00, 
                    /* 0020 */    0x00, 0xB0, 0xEF
                })
                CreateByteField (HPTF, 0x0F, PDMA)
                CreateByteField (HPTF, 0x16, PPIO)
                Name (IDTF, Buffer (0x0E)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                })
                CreateByteField (IDTF, One, IDMA)
                CreateByteField (IDTF, 0x08, IPIO)
                Name (DDTF, Buffer (0x1C)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x00, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xB0, 0xE3, 0x00, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xB0, 0xE3
                })
                CreateByteField (DDTF, One, DDMA)
                CreateByteField (DDTF, 0x08, DPIO)
                CreateByteField (DDTF, 0x0F, DTAT)
                CreateByteField (DDTF, 0x16, DTFT)
                Name (DGTF, Buffer (0x23)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x00, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xB0, 0xE3, 0x00, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xB0, 0xE3, 0x10, 0x03, 0x00, 0x00, 
                    /* 0020 */    0x00, 0xB0, 0xEF
                })
                CreateByteField (DGTF, One, GDMA)
                CreateByteField (DGTF, 0x08, GPIO)
                CreateByteField (DGTF, 0x0F, GTAT)
                CreateByteField (DGTF, 0x16, GTFT)
                Method (_GTF, 0, NotSerialized)
                {
                    If (^^DIP1)
                    {
                        Store (^^BDM1, PDMA)
                        Store (^^BPI1, PPIO)
                        Return (HPTF)
                    }
                    Else
                    {
                        Store (^^BDM1, HDMA)
                        Store (^^BPI1, HPIO)
                        Return (HDTF)
                    }
                }
            }
        }
    }

    Scope (\_SB.PCI0.SAT1)
    {
        Device (PRIM)
        {
            Name (_ADR, Zero)
            Name (BGTM, Buffer (0x14) {})
            CreateDWordField (BGTM, Zero, GTP0)
            CreateDWordField (BGTM, 0x04, GTD0)
            CreateDWordField (BGTM, 0x08, GTP1)
            CreateDWordField (BGTM, 0x0C, GTD1)
            CreateDWordField (BGTM, 0x10, GTMF)
            Name (BPI0, Zero)
            Name (BDM0, Zero)
            Name (BPI1, Zero)
            Name (BDM1, Zero)
            Name (DIP0, Zero)
            Name (DIP1, Zero)
            Name (GTME, Zero)
            Method (_GTM, 0, NotSerialized)
            {
                If (LNot (GTME))
                {
                    Or (GTMF, One, GTMF)
                    Store (0x78, GTP0)
                    Store (0x14, GTD0)
                    Store (Zero, GTP1)
                    Store (Zero, GTD1)
                    Or (GTMF, 0x10, GTMF)
                }

                Store (One, GTME)
                Return (BGTM)
            }

            Method (_STM, 3, NotSerialized)
            {
                CreateDWordField (Arg0, Zero, STP0)
                CreateDWordField (Arg0, 0x04, STD0)
                CreateDWordField (Arg0, 0x08, STP1)
                CreateDWordField (Arg0, 0x0C, STD1)
                CreateDWordField (Arg0, 0x10, STMF)
                Store (STP0, GTP0)
                Store (STD0, GTD0)
                Store (STMF, GTMF)
                Store (Zero, DIP0)
                Store (Zero, DIP1)
                If (LEqual (SizeOf (Arg1), 0x0200))
                {
                    CreateWordField (Arg1, 0x9C, M078)
                    If (LAnd (^MSTR.DIPP (), And (M078, 0x08)))
                    {
                        Store (One, DIP0)
                    }

                    Store (\DPIO (STP0, And (STMF, 0x02)), Local0)
                    Store (\DUDM (STD0, And (STMF, One)), Local1)
                    Store (\FDMA (Local0, Local1), BDM0)
                    Store (\FPIO, Local0)
                    BPI0
                }
            }

            Device (MSTR)
            {
                Name (_ADR, Zero)
                Method (DIPP, 0, NotSerialized)
                {
                    Return (\DPP4)
                }

                Name (HDTF, Buffer (0x1C)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x03, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xA0, 0xEF
                })
                CreateByteField (HDTF, 0x0F, HDMA)
                CreateByteField (HDTF, 0x16, HPIO)
                Name (HPTF, Buffer (0x23)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x03, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00, 0x00, 
                    /* 0020 */    0x00, 0xA0, 0xEF
                })
                CreateByteField (HPTF, 0x0F, PDMA)
                CreateByteField (HPTF, 0x16, PPIO)
                Name (IDTF, Buffer (0x0E)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                })
                CreateByteField (IDTF, One, IDMA)
                CreateByteField (IDTF, 0x08, IPIO)
                Name (DDTF, Buffer (0x1C)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xA0, 0xE3
                })
                CreateByteField (DDTF, One, DDMA)
                CreateByteField (DDTF, 0x08, DPIO)
                CreateByteField (DDTF, 0x0F, DTAT)
                CreateByteField (DDTF, 0x16, DTFT)
                Name (DGTF, Buffer (0x23)
                {
                    /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 0x00, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00, 0x00, 0x00, 
                    /* 0018 */    0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03, 0x00, 0x00, 
                    /* 0020 */    0x00, 0xA0, 0xEF
                })
                CreateByteField (DGTF, One, GDMA)
                CreateByteField (DGTF, 0x08, GPIO)
                CreateByteField (DGTF, 0x0F, GTAT)
                CreateByteField (DGTF, 0x16, GTFT)
                Method (_GTF, 0, NotSerialized)
                {
                    If (^^DIP0)
                    {
                        Store (^^BDM0, PDMA)
                        Store (^^BPI0, PPIO)
                        Return (HPTF)
                    }
                    Else
                    {
                        Store (^^BDM0, HDMA)
                        Store (^^BPI0, HPIO)
                        Return (HDTF)
                    }
                }
            }
        }
    }
}

